
                page    ,132
                %out    Save/RestScreen
                name    SRSCR
                title   Copyright (c) Hewlett-Packard Co. 1985-1987

;
; HISTORY
;       1.01    091587  jhc     Fixed RestoreScreen to restore video signal
;                               only after a time delay in order to prevent
;                               screen 'bounce'.  Also removed an unused
;                               error handler.
;


_TEXT           segment byte    public  'CODE'
                assume  cs:_TEXT


NO_STDGRABENTRY =       1

                .xlist
                include dc.inc
                include ic.inc
                include cgaherc.inc
                include abs0.inc
                include oem.inc
                include grabber.inc
                .list

                extrn   MAX_TOTGRPH:abs
                extrn   MAX_CDSIZE:abs

                extrn   DC:byte
                extrn   IC:byte
                extrn   fVectra:byte
                extrn   SaveTextSize:word
                extrn   SaveGrphSize:word

                extrn   GetHpVideoSeg:near
                extrn   OemBeep:near
                extrn   GetMode:near
                extrn   SetMode:near

                public  SaveScreen
                public  RestoreScreen
ifdef   HERC_ETCS ; TAIWAN
                public  ClearCsiStatusLine
endif


FALSE           =       0
TRUE            =       1
ifdef   HERC_ETCS ; TAIWAN
TextSize        =    1000h
ET_Text         =    4000h
ET_Grph         =    8000h
ET_Gap          =    4000h
;
fCsiInstalled       db      0               ;TRUE if CSI has been installed
                                            ;before Windows
csiSysMode          dw      ?               ;to remember system mode. Meaningless
                                            ;if fCsiInstalled == FALSE
SYSMODE_TAIWAN      equ     88
SYSMODE_US          equ     01
endif


                subttl  SaveScreen


;
; SaveScreen - save the current display context
;
; ENTRY
;       ax       =  size in bytes of screen save area
;       ds       =  cs
;       es:di    -> screen save area
; EXIT
;       nc       =  screen was successfully saved
;       cy       =  unable to save screen
; USES
;       all except bp
;
SaveScreen      proc    far
                assume  ds:_TEXT

ifdef   HERC_ETCS ; TAIWAN
                push    ax
                push    cx
                push    dx
                push    bx
                mov     bl, FALSE             ;fCsiInstalled = FALSE
                mov     ax,0db80h             ;Query mode:
                mov     cx,1h                 ;INT 16h
                int     16h                   ;Entry: AX=db80h,CX=1h
                or      ax, ax                ;Is Chinese system exist ?
                jne     no_mode_change1       ; No,
                mov     bl, TRUE               ;fCsiInstalled = TRUE
no_mode_change1:
                mov     cs:[csiSysMode], dx
                mov     cs:[fCsiInstalled], bl
                pop     bx
                pop     dx
                pop     cx
                pop     ax
endif

                call    Getmode
                mov     [DC.dcfSwitchGmt],FALSE
                cmp     ax,[SaveTextSize]
                je      ssChkAlloc
                mov     [DC.dcfSwitchGmt],TRUE
ssChkAlloc:
                mov     dx,MAX_CDSIZE
                add     dx,[IC.icScrLen]
                cmp     ax,dx
                jae     ssSaveDcIc
                jmp     ssErr
ssSaveDcIc:
                cld
                mov     si,offset DC
                mov     cx,(SIZE DeviceContext + SIZE InfoContext)/2
                if      (SIZE DeviceContext + SIZE InfoContext) AND 1
                movsb
                endif
                rep     movsw
ssSaveBiosData:
                xor     ax,ax
                mov     ds,ax
                assume  ds:Abs0

                mov     si,offset CrtMode
                mov     cx,(SIZE VideoBiosData)/2
                if      (SIZE VideoBiosData) AND 1
                movsb
                endif
                rep     movsw

ssSaveScreen0:

                mov     cx,cs:[IC.icScrLen]
                lds     si,cs:[IC.iclpScr]
                cmp     cs:[DC.dcfSwitchGmt],TRUE
                jne     ssSaveScreen1

                xor     si,si
ifdef  HERC_ETCS ; TAIWAN
                cmp     cx,TextSize             ;Is Text mode ?
                jne     do_graphic_mode         ; No,
                mov     cx,ET_Text              ;Save text buffer,compare bufrfer,font bank
                shr     cx,1
                rep     movsw
                rcl     cx,1
                rep     movsb
                add     si,ET_Gap
                mov     cx,ET_Grph
                shr     cx,1
                rep     movsw
                rcl     cx,1
                rep     movsb
                jmp     short ssX
do_graphic_mode:
                mov     cx,MAX_TOTGRPH
else
                mov     cx,MAX_TOTGRPH
endif
ssSaveScreen1:
                shr     cx,1
                rep     movsw
                rcl     cx,1
                rep     movsb
ssX:
                clc
                ret
ssErr:
                call    OemBeep
                stc
                ret
SaveScreen      endp


                subttl  RestoreScreen
                page


;
; RestoreScreen - restore the previously saved display context
;
; ENTRY
;       ax       =  size in bytes of screen save area
;       ds       =  cs
;       es:di    -> screen save area
; EXIT
;       nc       =  screen was successfully restored
;       cy       =  unable to restore screen
; USES
;       all except bp
;
RestoreScreen   proc    far
                assume  ds:nothing
                cld
                mov     ax,es                   ;xchg ds, es
                mov     bx,ds
                mov     es,bx                   ;now es = cs
                mov     ds,ax                   ;now ds = es on entry
                mov     si,di
rsRestDcIc:
                mov     di,offset DC
                mov     cx,(SIZE DeviceContext + SIZE InfoContext)/2
                if      (SIZE DeviceContext + SIZE InfoContext) AND 1
                movsb
                endif
                rep     movsw

                call    SetMode
rsRestBiosData:
                xor     ax,ax
                mov     es,ax
                assume  es:Abs0

                mov     di,offset CrtMode
                mov     cx,(SIZE VideoBiosData)/2
                if      (SIZE VideoBiosData) AND 1
                movsb
                endif
                rep     movsw


rsRestScreen0:

                mov     cx,cs:[IC.icScrLen]
                les     di,cs:[IC.iclpScr]
                cmp     cs:[DC.dcfSwitchGmt],TRUE
                jne     rsRestScreen1

                xor     di,di
ifdef  HERC_ETCS ; TAIWAN
                cmp     cx,TextSize             ;Is Text mode ?
                jne     do_graphic_mode1        ; No,
                mov     cx,ET_Text              ;Save text buffer,compare bufrfer,font bank
                shr     cx,1
                rep     movsw
                rcl     cx,1
                rep     movsb
                add     di,ET_Gap
                mov     cx,ET_Grph
                shr     cx,1
                rep     movsw
                rcl     cx,1
                rep     movsb
                jmp     short ssY
do_graphic_mode1:
                mov     cx,MAX_TOTGRPH
else
                mov     cx,MAX_TOTGRPH
endif
rsRestScreen1:
                shr     cx,1
                rep     movsw
                rcl     cx,1
                rep     movsb

                loop    $                       ;let screen settle before
                loop    $                       ;final mode set (video on)

ifdef   HERC_ETCS ; TAIWAN
ssY:
endif
                mov     al,cs:[DC.dcModeCtl]
                and     al,NOT MC_ENABLE_BLINK  ;kill blinking/turn on video
                mov     dx,MODE_CONTROL
                out     dx,al

ifdef   HERC_ETCS ; TAIWAN
;We now restore the session's system mode. Note that we do not
;restore its system mode before we restore text code buffer. This is
;because the CSI system will start to refresh text to graphic buffer
;and may cause incorrect result if we allow it to refresh before we restore
;its true code buffer content.
;
                cmp     byte ptr cs:[fCsiInstalled], FALSE
                je      rsSysModeSet
                push    ax
                push    cx
                push    dx
                mov     ax, 0DB80h
                mov     cx, 2
                mov     dx, cs:[csiSysMode]
                int     16h
                pop     dx
                pop     cx
                pop     ax
rsSysModeSet:

                clc
;here for buffer clear -lei-
        cld
        push    ax
        push    dx
;Check if Chinese system exist
        mov     ax,0db80h
        mov     cx,1h
        int     16h
        cmp     ax,0h
        jne     no_Chinese_system

        call    ClearCsiStatusLine

        mov     ax,0db80h             ;Check mode
        mov     cx,1h
        int     16h
        cmp     ax,0h
        jne     Is_TEXT_Mode1
        cmp     dx,1h
        je      Is_TEXT_Mode1

;Change Chinese DOS to English mode
        mov     ax,0db80h
        mov     cx,2h
        mov     dx,1
        int     16h
;Change Chinese system to Chinese mode
        mov     ax,0db80h
        mov     cx,2h
        mov     dx,88
        int     16h
        loop    $                       ;let screen settle before
        loop    $                       ;final mode set (video on)
Is_TEXT_Mode1:
no_Chinese_system:
        pop     dx
        pop     ax
endif

                clc
                ret
RestoreScreen   endp

ifdef HERC_ETCS ; TAIWAN
ClearCsiStatusLine  proc    near
        push    es
        push    di
        push    ax
        push    cx
        push    dx

;----------------------------------------------;
;Initial ET refresh checking area              ;
;----------------------------------------------;
;Store AX to ES:DI points area                 ;
; word by word for CX times                    ;
; Where AX    = 0000 (initial value)           ;
;       ES:DI = B000:10e0 (checking area)      ;
;       CX    = 2048 words (4K bytes)          ;
;----------------------------------------------;
        mov     cx,2048
        mov     ax,0b000h
        mov     es,ax
        mov     ax,10e0h
        mov     di,ax
        xor     ax,ax
        rep     stosw
;----------------------------------------------------;
; Clear the graphic mode buffer to remove destroyed  ;
; status line.                                       ;
;----------------------------------------------------;
;           screen     It's starting addess in buffer;
; line 0 ------------         B800:0000              ;
; line 1 ------------         B800:2000              ;
; line 2 ------------         B800:4000              ;
; line 3 ------------         B800:6000              ;
; line 4 ------------         B800:0050              ;
; line 5 ------------         B800:2050              ;
;   .         .                   .                  ;
;   .         .                   .                  ;
;                                                    ;
;   Every line is 640 dots, a dot denotes by a bit,  ;
; so there need 80 bytes to denotes a scan line.     ;
;----------------------------------------------------;
;----------------------------------------------------;
;              Area 0     (8 lines)                  ;
;----------------------------------------------------;
        mov     cx,320
        mov     ax,0b800h
        mov     es,ax
        mov     ax,1d60h
        mov     di,ax
        xor     ax,ax
        rep     stosw
;----------------------------------------------------;
;              Area 1                                ;
;----------------------------------------------------;
        mov     cx,320
        mov     ax,3d60h
        mov     di,ax
        xor     ax,ax
        rep     stosw
;----------------------------------------------------;
;              Area 2                                ;
;----------------------------------------------------;
        mov     cx,320
        mov     ax,5d60h
        mov     di,ax
        xor     ax,ax
        rep     stosw
;----------------------------------------------------;
;              Area 3                                ;
;----------------------------------------------------;
        mov     cx,320
        mov     ax,7d60h
        mov     di,ax
        xor     ax,ax
        rep     stosw
;Draw a line
        mov     cx,40
        mov     ax,7d10h
        mov     di,ax
        mov     ax,0ffffh
        rep     stosw

        pop     dx
        pop     cx
        pop     ax
        pop     di
        pop     es
        ret
ClearCsiStatusLine  endp
endif

_TEXT           ends
                end
